public interface CharMatrixInterface
{
    // Get the number of rows of the character matrix
    int getNumRows();
    
    // Get the number of columns of the character matrix
    int getNumColumns();
    
    // Get the character at row i, column j.  The precondition
    // is that 0 <= i < getNumRows() and 0 <= j < getNumColumns
    char getEntry(int i, int j);
    
    // Set the character at row i, column j.  The precondition is
    //  that 0 <= i < getNumRows() and 0 <= j < getnumColumns()
    public void setEntry(int i, int j, char newValue);
    
    // toString:  Represent the array as a character string with newlines,
    // rows labeled with the last digit of the row number, columns
    // labeled with the last digit of the column number.  The row
    // numbers should be separated from the data by vertical bars.
    //
    // Example:
 
    //  0123456789012345678901
    //0|XXXXXXXXXXXXXXXXXXXXXX
    //1|X     XX    X        X
    //2|X XXX    XX X X XXX XX
    //3|X  X  XX X  X X   X XX
    //4|X X  X XXX X  X XX  XX
    //5|X XXXX X     X  X  XXX
    //6|X       X XX  X  XX  X
    //7|X XXX XX XX X X X    X
    //8|XX     X      X X X XX
    //9|X  XX X XXX XX    X  X
    //0|X X       X X X X X XX
    //1|X   XX XX     X   X XX
    //2|XX X     XX X XXX X  X
    //3|X    X XXXX     X XX X
    //4|X XXX     X XXXXXXG  X
    //5|X    XX X   XX XXXXX X
    //6|XXXX    X X    XX X  X
    //7|X    XX   X X X     XX
    //8|XXXXXXXXXXXXXXXXXXXXXX
    public String toString(); 
}
